unit UHintsOverLine;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, Series, ExtCtrls, TeeProcs, Chart;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TLineSeries;
    procedure FormCreate(Sender: TObject);
    procedure Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
   OnSeriesPoint : Boolean;
   OnLegendPoint : Boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
     Series1.FillSampleValues(10);
     Chart1.View3D := False;
end;

procedure TForm1.Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var tmpL,tmpL2,ClickedValue : Integer;
begin
  clickedvalue := -1;
  tmpL2:= -1;

  With Chart1 do
  begin
    If (Series1.Clicked(X, Y) <> -1) And (not OnSeriesPoint) Then
    begin
       Canvas.Brush.Style := bsSolid;
       Canvas.Pen.Color := clBlack;
       Canvas.Brush.Color := clWhite;
       canvas.TextOut(x+10,y,FormatFloat('#.00',Series1.XScreenToValue(x))+','+FormatFloat('#.00',Series1.YScreenToValue(y)));
       OnSeriesPoint := True;
       ClickedValue:= Series1.Clicked(x,y);
    End;
    //Repaint Chart to clear Textoutputted Mark
    If (ClickedValue=-1) And (OnSeriesPoint) Then
    begin
      OnSeriesPoint := False;
      invalidate;
    End;

    tmpL := Chart1.Legend.Clicked(X, Y);
    If (tmpL <> -1) And ((tmpL <> tmpL2) Or (not OnLegendPoint)) Then
    begin
       repaint;
       Canvas.Brush.Color := Series1.LegendItemColor(tmpL);
       Canvas.Rectangle( X, Y, X + 20, Y + 20);
       Canvas.Brush.Color := clWhite;
       canvas.TextOut(x+15,y+7,FormatFloat('#.00',Series1.XValues.Items[Series1.LegendToValueIndex(tmpl)]));
       tmpL2 := tmpL;
       OnLegendPoint := True;
    End;

    If (tmpL2 = -1) And (OnLegendPoint) Then
    begin
       OnLegendPoint := False;
       Invalidate;
    End;
  End;
end;

end.
